From b5883a9e4561a6a691b1253a613c5070796e9b7d Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 30 2016 16:49:16 +0000
Subject: [PATCH 367/1001] Try splitting out cache work into its own process, mediated by redis.


---

diff --git a/fedmsg.d/testconfig.py b/fedmsg.d/testconfig.py
index e85072e..c2f68a1 100644
--- a/fedmsg.d/testconfig.py
+++ b/fedmsg.d/testconfig.py
@@ -4,6 +4,9 @@ config = {
     # Production ready.
     'hubs.sqlalchemy.uri': 'sqlite:////var/tmp/hubs.db',
 
+    # For communication between fedmsg-hub and the cache worker farm
+    'hubs.redis.work-queue-name': 'fedora-hubs-work-queue',
+
     'endpoints': {
         "fedora-infrastructure": [
             "tcp://hub.fedoraproject.org:9940",
diff --git a/hubs/consumer.py b/hubs/consumer.py
index c6e0d7b..ef4b6e2 100755
--- a/hubs/consumer.py
+++ b/hubs/consumer.py
@@ -1,8 +1,8 @@
 # The fedora hubs backend daemon
 
 import collections
+import json
 import threading
-import time
 
 import munch
 
@@ -10,12 +10,13 @@ import datanommer.models
 import fedmsg.consumers
 import fedmsg.meta
 
+import retask.task
+import retask.queue
+
 import hubs.app
 import hubs.models
 import hubs.widgets
 
-from hubs.widgets.base import invalidate_cache
-
 import logging
 log = logging.getLogger("hubs")
 
@@ -43,10 +44,13 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         super(CacheInvalidatorExtraordinaire, self).__init__(*args, **kwargs)
 
         self.uri = self.hub.config.get('hubs.sqlalchemy.uri', None)
+        self.queue_name = self.hub.config.get('hubs.redis.work-queue-name', None)
         self.junk_suffixes = self.hub.config.get('hubs.junk_suffixes', [])
 
         if not self.uri:
             raise ValueError('hubs.sqlalchemy.uri must be present')
+        if not self.queue_name:
+            raise ValueError('hubs.sqlalchemy.uri must be present')
 
         fedmsg.meta.make_processors(**self.hub.config)
 
@@ -64,6 +68,11 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
     def make_session(self):
         return hubs.models.init(self.uri)
 
+    def make_queue(self):
+        queue = retask.queue.Queue(self.queue_name)
+        queue.connect()
+        return queue
+
     def rebuild_hubs_hint_lookups(self, session):
         self.checks_by_topic = collections.defaultdict(list)
         self.checks_by_category = collections.defaultdict(list)
@@ -105,10 +114,11 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         return self.checks_by_topic and self.checks_by_category
 
     def consume(self, raw_msg):
+        queue = self.make_queue()
         session = self.make_session()
         try:
             with hubs.app.app.app_context():  # so url_for works
-                self.work(session, raw_msg)
+                self.work(session, queue, raw_msg)
             session.commit()  # transaction is committed here
         except:
             session.rollback()  # rolls back the transaction
@@ -116,7 +126,7 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         finally:
             session.close()
 
-    def work(self, session, raw_msg):
+    def work(self, session, queue, raw_msg):
         topic, msg = raw_msg['topic'], raw_msg['body']
         category = topic.split('.')[3]
         usernames = fedmsg.meta.msg2usernames(msg, **self.hub.config)
@@ -126,7 +136,6 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
                 log.info("Dropping %r", topic)
                 return
 
-        start = time.time()
         log.debug("CacheInvalidatorExtraordinaire received %s %s",
                   msg['msg_id'], msg['topic'])
 
@@ -158,18 +167,10 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         # see if any tell us that we should nuke various data caches.
         for check, widget in checks:
             if check(msg, session, widget):
-                # Get a real widget, because we update last_refreshed on it.
-                widget = hubs.models.Widget.by_idx(session, widget.idx)
-                log.info("! Invalidating cache for %r" % widget)
-                # Invalidate the cache...
-                invalidate_cache(widget, **widget.config)
-                # Rebuild it.
-                log.info("! Rebuilding cache for %r" % widget)
-                widget.module.data(session, widget, **widget.config)
-                # TODO -- fire off an EventSource notice that we updated stuff
-
-        log.debug("Done.  %0.2fs %s %s",
-                  time.time() - start, msg['msg_id'], msg['topic'])
+                task = retask.task.Task(json.dumps({'idx': widget.idx}))
+                log.debug("  Sending %r to workers. (backlog is %r)" % (
+                    task, queue.length))
+                queue.enqueue(task)
 
     def stop(self):
         log.info("Cleaning up CacheInvalidatorExtraordinaire.")
diff --git a/hubs/worker.py b/hubs/worker.py
new file mode 100755
index 0000000..78807dc
--- /dev/null
+++ b/hubs/worker.py
@@ -0,0 +1,68 @@
+import hubs.app
+import hubs.models
+
+import hubs.widgets.base
+
+import fedmsg.config
+config = fedmsg.config.load_config()
+
+import retask.queue
+
+import json
+import sys
+import logging
+import logging.config
+log = logging.getLogger('hubs.worker')
+
+
+def work(session, widget_idx):
+    # Get a real widget, because we update last_refreshed on it.
+    widget = hubs.models.Widget.by_idx(session, widget_idx)
+    log.info("! Invalidating cache for %r" % widget)
+    # Invalidate the cache...
+    hubs.widgets.base.invalidate_cache(widget, **widget.config)
+    # Rebuild it.
+    log.info("! Rebuilding cache for %r" % widget)
+    widget.module.data(session, widget, **widget.config)
+    # TODO -- fire off an EventSource notice that we updated stuff
+
+def handle(idx):
+    session = hubs.models.init(config['hubs.sqlalchemy.uri'])
+
+    try:
+        with hubs.app.app.app_context():  # so url_for works
+            work(session, idx)
+        session.commit()  # transaction is committed here
+    except:
+        session.rollback()  # rolls back the transaction
+        raise
+    finally:
+        session.close()
+
+def main(args):
+
+    # TODO -- manage signal handling for clean shutdown
+
+    logging.config.dictConfig(config['logging'])
+    logging.basicConfig()
+
+    name = config['hubs.redis.work-queue-name']
+    log.info("Worker starting, connecting to retask queue %r." % name)
+    queue = retask.queue.Queue(name)
+    queue.connect()
+
+    try:
+        log.info("Entering work loop.")
+        while True:
+            task = queue.wait()  # Wait forever...  timeout is optional.
+            log.info("Working on %r" % task)
+            item = json.loads(task.data)
+            idx = item['idx']  # A widget ID
+            handle(idx)
+    except KeyboardInterrupt:
+        pass
+
+    return 0
+
+if __name__ == '__main__':
+    sys.exit(main(sys.argv))
